#pragma once

/*
* MPIA - GEIRS project
*
* $Id: FitsImg.h 793M 2020-10-06 16:41:53Z (local) $
*
*/

#include <string>
#include <vector>
#include <valarray>

#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_URL
#undef PACKAGE_VERSION

#include "fitsio.h"
#include "Rotflip.h"
#include "Subwin.h"

using namespace std ;

/** 
* @since 2020-03-06
* @author Richard J. Mathar
*/
class FitsImg
{

public:
	/** Names of the input files.
	*/
	vector<string> iname ;

	FitsImg(char *fitsInname) ;
	FitsImg(int argc, char *fitsInname[]) ;

	void dumpRaw(const string & ofile, const Rotflip & rf, float cuts[2], bool raw, int lutidx, 
		double gammExp, const int bin, bool verb, int compr=5) ;
	void dumpRaw(fitsfile * iex, const Rotflip & rf, float cuts[2], 
		const string & ofile, int exIdx,bool raw, int lutidx, double gammExp, const int bin, bool verb,
		int compr=5) ;

protected:

private:
	static void flip( float * farr, const long axs[3], const Rotflip &rf, const Subwin & subout) ;
	static valarray<float> serial(const float * farr, const Subwin & subout, const float cuts[2], 
				const long axs[3], const int slic,const double gammExp, const int bin) ;
	static int qsortCmpFlt(const void *i, const void *j) ;

} ; /* FitsImg */
